#
# spec file for package clisp (Version 2.26)
# 
# Copyright  (c)  2001  SuSE GmbH  Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
# 
# please send bugfixes or comments to feedback@suse.de.
#

# neededforbuild  autoconf automake openssl openssl-devel postgresql postgresql-devel tetex texinfo xf86 xpm
# usedforbuild    aaa_base aaa_dir autoconf automake base bash bindutil binutils bison bzip compress cpio cpp cracklib cyrus-sasl db devs diffutils e2fsprogs file fileutils findutils flex gawk gcc gdbm gdbm-devel gettext glibc glibc-devel gpm gppshare grep groff gzip kbd less libtool libz m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg openssl openssl-devel pam pam-devel patch perl postgresql postgresql-devel ps rcs readline rpm sendmail sh-utils shadow strace syslogd sysvinit te_ams te_latex tetex texinfo textutils timezone unzip util-linux vim xdevel xf86 xshared

Name:         clisp
Copyright:    1992,93 Bruno Haible und Michael Stoll, 1994-97 Bruno Haible und Marcus Daniels
Group:        Development/Languages
Provides:     clisp
Autoreqprov:  on
Version:      2.26
Release:      66
Summary:      A Common-Lisp interpreter
Url:     http://clisp.cons.org
Source:  ftp://clisp.cons.org/pub/lisp/clisp/source/latest/clisp-%{version}.tar.bz2
Patch:   clisp-%{version}.dif

%description
Common Lisp is a high-level, all-purpose programming language. CLISP
is an implementation of Common Lisp that closely follows the book
"Common Lisp - The Language" by Guy L. Steele Jr. This package includes an
interactive programming environment with interpreter, compiler and
debugger.  This environment will be started by the command
clisp
The documentation of CLISP is placed in the directories
/usr/share/doc/packages/clisp/
/usr/share/doc/packages/clisp/doc/
As well as the conventional CLISP, the package also includes CLX,
an extension of CLISP for the X Window System. Of course
X11 has to be installed before the command
clx
is called. The description of this CLX version (new-clx) is placed in
/usr/share/doc/packages/clisp/clx/
with the file README. The subdirectory
/usr/share/doc/packages/clisp/clx/demos/
contains two nice applications.

Authors:
--------
    Bruno Haible <haible@ma2s2.mathematik.uni-karlsruhe.de>
    Michael Stoll <michael@rhein.iam.uni-bonn.de>
    Marcus Daniels <marcus@sysc.pdx.edu>
    Gilbert Baumann <gilbert@ma2s2.mathematik.uni-karlsruhe.de>

SuSE series: d

%prep
%setup
%patch 
#

%build
#
export PATH="$PATH:."
WHERE="--prefix=/usr --exec-prefix=/usr --fsstnd=suse"
#
# --with-newreadline, --with-newnewreadline, --with-readline is better
# --with-module-stdwin --with-x11 is archaic, better use
# CLX and Garnet 3.0
#
FEATURES="--with-readline --with-dynamic-ffi --with-dynamic-modules \
          --with-export-syscalls --with-gettext"
#
# -DIMMUTABLE=1 does not work
# -freg-struct-return does not work (function LINUX:DIV)
# Don't strip the executable, otherwise (disassemble #'cons)
# won't work.  Glibc 2.1 use some inlined assembler string
# functions which we do not want.
#
STRING="-U__USE_STRING_INLINES -U__NO_STRING_INLINES -D__NO_STRING_INLINES"
    CC="gcc"
CFLAGS="${RPM_OPT_FLAGS} -pipe ${STRING}"
CLFLAGS=""
LDFLAGS=""
prefix=/usr
exec_prefix=/usr
export CC CFLAGS CLFLAGS LDFLAGS prefix exec_prefix
SYSTEM="${RPM_ARCH}-suse-linux"
if test -e /lib/libc.so.6* ; then
    BIND=bindings/linuxlibc6
    case "${RPM_ARCH}" in
	ppc|powerpc)
	    CFLAGS="`echo $CFLAGS| sed 's@-O2@-O@'`"
	    ;;
	*)
    esac
else
    BIND=bindings/linuxlibc5
fi
#
# stdwin is archaic, queens is only a sample.
# The other three are really useful.
#
if test -e /usr/lib/libpq.a ; then
    POST="postgresql642"
 LDFLAGS="-L/usr/lib"
fi
 MODULES="wildcard regexp ${BIND} $POST"
XMODULES="wildcard regexp ${BIND} clx/new-clx $POST"
    OWD=$PWD
    cache=${PWD}/${SYSTEM}/config.cache
echo " ++ Making distclean ++"
for d in `find ./ -follow -name Makefile -printf '%%h '`; do
    test -f $d/Makefile && ( make -i -C $d/ distclean )
done
rm -rf ${SYSTEM}/
echo " ++ Removing configuration cache ++"
    (find ./ \( -name config.status -o \
		-name config.cache  -o \
		-name config.log \) | xargs -r rm -f )
if test ! -e ${SYSTEM}/Makefile ; then
    cd src/
    #echo " ++ Running autoconf ++"
    #( autoconf -l ./autoconf/ ) || exit 1
    echo " ++ Running configure ++"
    cd ../
    ./configure --config  \
	${SYSTEM}	  \
	${WHERE}	  \
	${FEATURES}
    cd ${SYSTEM}/
    echo " ++ Create Makefile ++"
    ./makemake ${WHERE} ${FEATURES} > Makefile
    echo " ++ First test ++"
    make intparam.h lispbibl.h
    cd ../
fi
cd ${SYSTEM}/
echo " ++ Building without X ++"
make MODULES="${MODULES}"
mv full fullnox
echo " ++ Building with X ++"
make MODULES="${XMODULES}"
echo " ++ Running checks ++ "
make check

%install
STRING="-U__USE_STRING_INLINES -U__NO_STRING_INLINES -D__NO_STRING_INLINES"
    CC="gcc"
CFLAGS="${RPM_OPT_FLAGS} -pipe ${STRING}"
CLFLAGS=""
LDFLAGS=""
prefix=/usr
exec_prefix=/usr
export CC CFLAGS CLFLAGS LDFLAGS prefix exec_prefix
SYSTEM="${RPM_ARCH}-suse-linux"
LSPDOC=%{_docdir}/clisp
DOCDOC=${LSPDOC}/doc
CLXDOC=${LSPDOC}/clx
LSPLIB=/usr/lib/clisp
CLXLIB=${LSPLIB}/full
install -d -o root -g root ${CLXDOC}
install -d -o root -g root ${CLXLIB}
install -d -o root -g root ${LSPLIB}/fullnox
(cd ${SYSTEM}/; make install INSTALL_DATA='install -c -m 0444 ' )
(cd ${SYSTEM}/fullnox/ ; \
 rm -f ${LSPLIB}/fullnox/* ; \
 install -m 0755 lisp.run     ${LSPLIB}/fullnox/ ; \
 install -m 0444 *            ${LSPLIB}/fullnox/   )
(cd ${SYSTEM}/clx/new-clx/; \
 install -c -m 0444 README      ${CLXDOC}/ ; \
 install -c -m 0444 README.SuSE ${CLXDOC}/ ; \
 tar cf - demos/ | (cd ${CLXDOC}/ ; tar xf - ) )
(cd ${SYSTEM}/clx/; \
 tar xfz clx-manual.tar.gz -C ${CLXDOC} )
chown -R root:root ${LSPDOC}/
chmod -R g+r,o+r   ${LSPDOC}/
rm -f ${CLXDOC}/*,v
rm -f ${CLXDOC}/.\#*
rm -f ${CLXDOC}/demos/*,v
rm -f ${CLXDOC}/demos/.\#*
rm -f ${CLXDOC}/demos/*.orig
find ${LSPLIB}/ -name '*.dvi' | xargs -r rm -f
mkdir -p /usr/share/man/man1
mkdir -p /usr/share/man/man3
mv /usr/man/man1/clisp.1      /usr/share/man/man1/
mv /usr/man/man3/clreadline.3 /usr/share/man/man3/
gzip -9f /usr/share/man/man1/*.1 /usr/share/man/man3/*.3

%files
%doc %{_docdir}/clisp/
/usr/bin/clisp
/usr/lib/clisp/
%doc /usr/share/man/man1/clisp.1.gz
%doc /usr/share/man/man3/clreadline.3.gz
/usr/share/locale/*/LC_MESSAGES/clisp.mo

%changelog -n clisp
* Thu Aug 23 2001 - ro@suse.de
- fixed specfile to build on ppc
* Wed Jul 11 2001 - ro@suse.de
- update to 2.26
- no autoconf call at the moment
* Mon May 07 2001 - mfabian@suse.de
- bzip2 sources
* Tue Dec 05 2000 - werner@suse.de
- Update to 2000.03.06
- Use postgresql and postgresql-devel
- Change libpq paths accordingly to postgresql-devel
- Make clx demos working as found in README
* Fri Dec 01 2000 - ro@suse.de
- neededforbuild: postgresql
* Mon Jun 05 2000 - uli@suse.de
- moved docs to %%{_docdir}
* Mon Jan 31 2000 - ro@suse.de
- fixed libc6-checking again
* Mon Jan 31 2000 - werner@suse.de
- Tried to get PPC working (does NOT work)
- /usr/man -> /usr/share/man
* Thu Oct 28 1999 - werner@suse.de
- Reintroduce FIFO hack for a missed tty
* Mon Oct 11 1999 - werner@suse.de
- New version clisp-1999-07-22
  * remove Makefile.Linux and use spec instead
* Mon Sep 13 1999 - bs@suse.de
- ran old prepare_spec on spec file to switch to new prepare_spec.
* Wed Mar 31 1999 - werner@suse.de
- No string inlines
* Tue Mar 30 1999 - werner@suse.de
- Work around clisp's buffered *TERMINAL-IO* within a
  background build process
* Mon Mar 29 1999 - werner@suse.de
- New version clisp-1999-01-08
- Make -X and -F identical
* Fri Dec 18 1998 - werner@suse.de
- New version clisp-1998-09-09
- Change option -F (full version) to option -X
  * Split modules into wildcard, regexp, bindings/linuxlibc6 on
  one hand and new-clx on the other one.
  * Replace normal version with full version without new-clx
  * New version including new-clx and all other modules
* Fri Feb 20 1998 - werner@suse.de
- New Version 1997-12-06
- clx script removed
- Option -F for clisp added
* Mon Jun 09 1997 - werner@suse.de
- Patch for GC in clisp included.
* Fri Jun 06 1997 - werner@suse.de
- New package: clisp version 1997-05-03
- Added nclx version 1996-10-12 a
  clx re-implementation of Gilbert Baumann
- clisp+clx is called with /usr/bin/clx
  clisp is called with /usr/bin/clisp
